#CONTROLCODES 1
DEF FN SIGNED.BYTE(N) = N+256*(N>127)
OB = PEEK(1):BANK PEEK(0),0
ROM.VERSION=FN SIGNED.BYTE(PEEK($FF80))
## IF ROM.VERSION < 0 THEN PRINT "PRE-RELEASE ROM"
GOOD.ROM = (ROM.VERSION < -45) OR (ROM.VERSION >= 45)
ROM.VERSION = ABS(ROM.VERSION)
BANK PEEK(0), OB

IF NOT GOOD.ROM THEN PRINT "{GRN}ROM VERSION:{WHT}";ROM.VERSION:DM$="HANGMAN REQUIRES A R45 RELEASE ROM OR LATER!":GOTO ERRORHALT
GOSUB SETREGVARS
GOSUB POKENOFLICKER
POKE C.REG,1:SYS $FF5F:IF PEEK(A.REG)<>$80 THEN GOSUB HIDEALL:MYMODE=$80:GOSUB NOFLICKERSCREEN:GOSUB SETDEFAULTPALETTE:
RECT 0,0,319,239,$C1

PRINT "{CR}  {YEL}LOADING{GRN}:{WHT} ML ROUTINES{GRN}
PRINT            "  --------------------{WHT}{CR}"
GOSUB SHOWALL
GOSUB POKEBVSAVE
GOSUB POKEFASTFWD
GOSUB POKEDECPAL
GOSUB POKESWAPLAYERS

SLEEP 15:CLS
LOAD "CHECKFILES"

POKESWAPLAYERS:
  RESTORE SWAPLAYERSDATA
  POKEMSG$="VERA LAYER SWAP"
  ML.ADDR=$750
  ML.SIZE=99
  GOTO POKEMLROUTINE

POKEDECPAL:
  RESTORE DECPALDATA
  POKEMSG$="PAL DEC ROUTINE"
  ML.ADDR=$600
  ML.SIZE=66
  GOTO POKEMLROUTINE

POKEFASTFWD:
   RESTORE FASTFWD650
   POKEMSG$="FAST FORWARD ROUTINE"
   ML.ADDR=$650
   ML.SIZE=49
   GOTO POKEMLROUTINE

POKEBVSAVE:
   RESTORE BVSAVE
   POKEMSG$="SCREEN SAVE ROUTINE"
   ML.ADDR=$700
   ML.SIZE=75
   GOTO POKEMLROUTINE

POKEMLROUTINE:
  PRINT "{CR}{YEL}POKING{GRN}: {WHT}";POKEMSG$;"{GRN}";
  FOR I = 0 TO (ML.SIZE-1)
      READ C
      POKE ML.ADDR+I, C
      PRINT ".";
  NEXT I
  PRINT "{CR}{WHT}"
  RETURN

NOFLICKERSCREEN:
 POKE A.REG, MYMODE
 SYS $410:GOTO SETDEFAULTPALETTE

POKENOFLICKER:
  RESTORE NOFLICKER
  FOR A=$410 TO $443
      READ C:POKE A,C
  NEXT A
  RETURN

## 52 BYTES
NOFLICKER:
 DATA $5A,$DA,$48,$A9,$FA,$8D,$21,$9F,$A9,$11,$8D,$22,$9F,$A9,$00,$8D
 DATA $20,$9F,$A2,$04,$A0,$80,$8D,$23,$9F,$88,$D0,$FA,$CA,$D0,$F5,$20,$DE,$FF
 DATA $85,$29,$CB,$20,$DE,$FF,$C9,$FF,$F0,$F8,$68,$18,$20,$5F,$FF,$FA,$7A,$60

## 64  BYTES
DECPALDATA:
  DATA $AD,$21,$9F,$48,$AD,$20,$9F,$48,$AD,$23,$9F,$AE,$23,$9F,$48,$29,$0F,$A8
  DATA $F0,$01,$88,$68,$4A,$4A,$4A,$4A,$F0,$01,$3A,$0A,$0A,$0A,$0A,$84,$20,$05
  DATA $20,$E0,$00,$F0,$01,$CA,$A8,$68,$8D,$20,$9F,$68,$8D,$21,$9F,$8C,$23,$9F
  DATA $8E,$23,$9F,$C6,$02,$A6,$02,$E0,$FF,$D0,$BF,$60


## 75 BYTES
BVSAVE:
   DATA $AA,$20,$C9,$FF,$9C,$4B,$07,$A9,$2C,$8D,$4C,$07,$A9,$01,$8D,$4D,$07,$A2
   DATA $23,$A0,$9F,$AD,$4B,$07,$38,$20,$B1,$FE,$B0,$29,$8E,$4E,$07,$AD,$4B,$07
   DATA $38,$ED,$4E,$07,$8D,$4B,$07,$AD,$4C,$07,$8C,$4E,$07,$ED,$4E,$07,$8D,$4C
   DATA $07,$AD,$4D,$07,$E9,0,$8D,$4D,$07,$0D,$4B,$07,$0D,$4C,$07,$D0,$CA,$20
   DATA $CC,$FF,$60

## 49 BYTES
FASTFWD650:
  DATA $E0,0,$D0,$05,$C0,0,$F0,$24,$88,$C8,$84,$22,$DA,$AA,$20,$C6,$FF,$7A
  DATA $20,$CF,$FF,$C9,$0D,$D0,$07,$88,$D0,$04,$C6,$22,$F0,$0C,$20,$B7,$FF,$29
  DATA $40,$F0,$EB,$20,$CC,$FF,$38,$60,$20,$CC,$FF,$18,$60

## 99 BYTES
SWAPLAYERSDATA:
  DATA $AD,$2D,$9F,$48,$AD,$2E,$9F,$48,$AD,$2F,$9F,$48,$AD,$30,$9F,$48,$AD,$31,$9F,$48,$AD,$32,$9F,$48,$AD,$33,$9F,$48,$AD,$34,$9F,$8D,$2D,$9F
  DATA $AD,$35,$9F,$8D,$2E,$9F,$AD,$36,$9F,$8D,$2F,$9F,$AD,$37,$9F,$8D,$30,$9F,$AD,$38,$9F,$8D,$31,$9F,$AD,$39,$9F,$8D,$32,$9F,$AD,$3A,$9F,$8D,$33,$9F
  DATA $68,$8D,$3A,$9F,$68,$8D,$39,$9F,$68,$8D,$38,$9F,$68,$8D,$37,$9F,$68,$8D,$36,$9F,$68,$8D,$35,$9F,$68,$8D,$34,$9F,$60

HIDEALL:
  GOSUB HIDEGRAPHICS:GOTO HIDETEXT
SHOWALL:
  GOSUB SHOWGRAPHICS:GOTO SHOWTEXT

HIDEGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER0.OFF:RETURN

SHOWGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER0.ON:RETURN

HIDETEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER1.OFF:RETURN

SHOWTEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER1.ON:RETURN

SETREGVARS:
  A.REG = $030C
  X.REG = $030D
  Y.REG = $030E
  C.REG = $030F
  SET.MEM = $FF99
  R0L=$02:R0H=$03:R0=R0L
  R1L=$04:R1H=$05:R1=R1L
  R2L=$06:R2H=$07:R2=R2L
  R3L=$08:R3H=$09:R3=R3L
  R4L=$A:R4H=$B:R4=R4L
  R5L=$C:R5H=$D:R5=R5L
  R6L=$E:R6H=$F:R6=R6L
  R7L=$10:R7H=$11:R7=R7L
  R8L=$12:R8H=$13:R8=R8L
  R9L=$14:R9H=$15:R9=R9L
  R10L=$16:R10H=$17:R10=R10L
  R11L=$18:R11H=$19:R11=R11L
  R12L=$1A:R12H=$1B:R12=R12L
  R13L=$1C:R13H=$1D:R13=R13L
  R14L=$1E:R14H=$1F:R14=R14L
  R15L=$20:R15H=$21:R15=R15L
  CHKOUT=$FFC9:CHKIN=$FFC6:CLRCHN=$FFCC
  MCIOUT=$FEB1:MACPTR=$FF44:
  VERA.DATA0=$9F23:VERA.DATA1=$9F24:VERA.CTRL=$9F25
  VERA.DCVIDEO=$9F29
  LAYER0.ON=16
  LAYER0.OFF=239
  LAYER1.ON=32
  LAYER1.OFF=223
  FB.CURSOR.POSITION=$FEFF
  FB.CURSOR.NEXTLINE=$FF02
  SCREEN.SIZE=$12C00
  RETURN


SETDEFAULTPALETTE:
 F$="DPAL.BIN":GOSUB FILEEXISTS
 IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
 RESTORE PALDATA
 POKE $9F20, 0
 POKE $9F21, $FA
 POKE $9F22, %00010001
 FOR I=1 TO 512:READ PALBYTE:POKE $9F23, PALBYTE:NEXT
 RETURN

## Palette DATA GB,R,GB,R .....
PALDATA:
  DATA $00,$00,$FF,$0F,$00,$08,$FE,$0A,$4C,$0C,$C5,$00,$0A,$00,$E7,$0E,$85,$0D
  DATA $40,$06,$77,$0F,$33,$03,$77,$07,$F6,$0A,$8F,$00,$BB,$0B,$00,$00,$11,$01
  DATA $22,$02,$33,$03,$44,$04,$55,$05,$66,$06,$77,$07,$88,$08,$99,$09,$AA,$0A
  DATA $BB,$0B,$CC,$0C,$DD,$0D,$EE,$0E,$FF,$0F,$11,$02,$33,$04,$44,$06,$66,$08
  DATA $88,$0A,$99,$0C,$BB,$0F,$11,$02,$22,$04,$33,$06,$44,$08,$55,$0A,$66,$0C
  DATA $77,$0F,$00,$02,$11,$04,$11,$06,$22,$08,$22,$0A,$33,$0C,$33,$0F,$00,$02
  DATA $00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F,$21,$02,$43,$04,$64,$06
  DATA $86,$08,$A8,$0A,$C9,$0C,$EB,$0F,$11,$02,$32,$04,$53,$06,$74,$08,$95,$0A
  DATA $B6,$0C,$D7,$0F,$10,$02,$31,$04,$51,$06,$62,$08,$82,$0A,$A3,$0C,$C3,$0F
  DATA $10,$02,$30,$04,$40,$06,$60,$08,$80,$0A,$90,$0C,$B0,$0F,$21,$01,$43,$03
  DATA $64,$05,$86,$07,$A8,$09,$C9,$0B,$FB,$0D,$21,$01,$42,$03,$63,$04,$84,$06
  DATA $A5,$08,$C6,$09,$F7,$0B,$20,$01,$41,$02,$61,$04,$82,$05,$A2,$06,$C3,$08
  DATA $F3,$09,$20,$01,$40,$02,$60,$03,$80,$04,$A0,$05,$C0,$06,$F0,$07,$21,$01
  DATA $43,$03,$65,$04,$86,$06,$A8,$08,$CA,$09,$FC,$0B,$21,$01,$42,$02,$64,$03
  DATA $85,$04,$A6,$05,$C8,$06,$F9,$07,$20,$00,$41,$01,$62,$01,$83,$02,$A4,$02
  DATA $C5,$03,$F6,$03,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$00
  DATA $22,$01,$44,$03,$66,$04,$88,$06,$AA,$08,$CC,$09,$FF,$0B,$22,$01,$44,$02
  DATA $66,$03,$88,$04,$AA,$05,$CC,$06,$FF,$07,$22,$00,$44,$01,$66,$01,$88,$02
  DATA $AA,$02,$CC,$03,$FF,$03,$22,$00,$44,$00,$66,$00,$88,$00,$AA,$00,$CC,$00
  DATA $FF,$00,$12,$01,$34,$03,$56,$04,$68,$06,$8A,$08,$AC,$09,$CF,$0B,$12,$01
  DATA $24,$02,$46,$03,$58,$04,$6A,$05,$8C,$06,$9F,$07,$02,$00,$14,$01,$26,$01
  DATA $38,$02,$4A,$02,$5C,$03,$6F,$03,$02,$00,$14,$00,$16,$00,$28,$00,$2A,$00
  DATA $3C,$00,$3F,$00,$12,$01,$34,$03,$46,$05,$68,$07,$8A,$09,$9C,$0B,$BF,$0D
  DATA $12,$01,$24,$03,$36,$04,$48,$06,$5A,$08,$6C,$09,$7F,$0B,$02,$01,$14,$02
  DATA $16,$04,$28,$05,$2A,$06,$3C,$08,$3F,$09,$02,$01,$04,$02,$06,$03,$08,$04
  DATA $0A,$05,$0C,$06,$0F,$07,$12,$02,$34,$04,$46,$06,$68,$08,$8A,$0A,$9C,$0C
  DATA $BE,$0F,$11,$02,$23,$04,$35,$06,$47,$08,$59,$0A,$6B,$0C,$7D,$0F,$01,$02
  DATA $13,$04,$15,$06,$26,$08,$28,$0A,$3A,$0C,$3C,$0F,$01,$02,$03,$04,$04,$06
  DATA $06,$08,$08,$0A,$09,$0C,$0B,$0F


FILEEXISTS:
  X$=F$:FE%=0:X$=X$+",S,R":OPEN 2,8,2,X$:CLOSE 2:OPEN 15,8,15:INPUT#15,X,X$,A,B
  CLOSE 15:FE%=(X<=20):RETURN

ERRORHALT:
  RECT 0,0,319,239,0:CLS
  P1=5:R%=0:G%=14:B%=2:GOSUB RGBPAL:P1=15:R%=2:G%=2:GOSUB RGBPAL:P1=7:R%=8:G%=8:B%=0:GOSUB RGBPAL
  PRINT "{CR}{CR}{YEL}  ERROR ENCOUNTERED{WHT}!":PRINT ":{GRN} {CR}";S$;"{WHT}{CR}":END

RGBPAL:
  A=P1*2:X=(G%*16)+B%:A=A+$FA00:SLEEP:VPOKE 1,A,X:A=A+1:SLEEP:VPOKE 1,A,R%:RETURN
